AutoCAD下繪製直線對稱中心線的方法

tags: AutoCAD    時間:2014-03-06 13:52:38
AutoCAD下繪製直線對稱中心線的方法簡介
 AutoCAD是目前國內應用最廣范的CAD系統之一,AutoCAD 功能強大,是一個通用的CAD平台,但是如果不根據本專業的需要進行二次開發,使用起來是很不方便的。畫對稱中心線是機械設計……
AutoCAD下繪製直線對稱中心線的方法正文

 AutoCAD是目前國內應用最廣范的CAD系統之一,AutoCAD 功能強大,是一個通用的CAD平台,但是如果不根據本專業的需要進行二次開發,使用起來是很不方便的。畫對稱中心線是機械設計中經常遇到的一個問題。

筆者用AutoLISP依據國家標準開發了兩個程序,可以很方便地解決直線對稱中心線的問題。

第一個程序適用於兩條邊是連續直線的情況。使用方法是:用LOAD命令裝入GLS.LSP,運行C:GSL,依據屏幕提示,分別選擇兩邊,自動繪製出中心線。
GSL.LSP:
(defun mid(pt1 pt2 ) 計算兩點之中點的功能函數
(setq pt (mapcar'+pt1 pt2 ))
(setq pt (mapcar'/pt'(2 2 2)))
)
(defun c:gsl/m cl1 cl cl2 e pt pt1 pt2 pt3 pt4 a)  (SETQ M 1)
 (WHILE M

(SETQ CL1 (ENTSEL"\n選擇第一條直線 "))

(cond

 ((not cl1 )  (prompt"\n 沒有發現實體"))

((/="LINE"(cdr (assoc 0 (setqe(entget (car cl1))))))
(prompt"\n 所選不是直線")

)

(t (prompt"找到了第一條直線”)

 (setq m nil);退出循環

)
  )
)
(setq cl (ssget (nth 0 (cdr cl1))));取得第一條直線的實體數據
(SETQ M 1)
(WHILE M
 (SETQ CL2 (ENTSEL"\n選擇第二條直線"))
 (if cl2

(if (ssmemb (car cl2) cl )


(progn


 (princ"\n選擇重複,重新選擇")


 (setq cl2 nil)


)

)
 )
 (cond

((not cl2 ) (prompt"沒有發現實體或重複"))
  ((/="LINE"(cdr (assoc 0 (setq e (entget (car cl2))))))


 (prompt"\n 所選不是直線")

)

(t (prompt"\n兩條直線已經選擇完畢")

 (setq m nil);;;退出循環

)
  )
 )
;;;取得第一直線兩端點的坐標
 (setq pt1 (cdr (assoc 10 e )) pt2 (cdr (assoc 11 e )))
 (setq e (entget (car cl1)));;取得第二條直線的實體數據
;;;取得第二直線兩端點的坐標
 (setq pt3 (cdr (assoc 10 e )) pt4 (cdr (assoc 11 e )))
;;調整端點
 (if (inters pt1 pt3 pt2 pt4 t)

(setq pt pt1


 pt1 pt2


pt2 pt

)
 )
;;;計算兩端中點坐標
 (setq pt1 (mid pt1 pt3 ))
 (setq pt2 (mid pt2 pt4 ))
 (setq a (angle pt1 pt2));計算中心線的傾角
 (setq pt2 (polar pt2 a 2.5));;計算中心線的第一個端點
 (setq pt1 (polar pt1 (+pi a ) 2.5))
 (command"layer""SET"5"");;設置中心線層
 (command "line" pt1 pt2 "");;畫出中心線
)
(princ "\nC:GSL has loaded")
(Princ "\n for symmetry line")
(princ)

第二個程序適用於階梯軸,階梯孔等各種情況。使用方法是:用LOAD命令裝入GLS1.LSP,運行C:GSL1,依據屏幕提示,分別選擇兩邊的端點,自動繪製出中心線。
GSL1.LSP

 


(defun mid(pt1 pt2 )

(setq pt (mapcar '+ pt1 pt2 ))

(setq pt (mapcar '/ pt '(2 2 2)))
)
(defun c:gsl1(/ p1 p1 p3 p4 a )
 ;;保存環境變數
 (setq os (getvar "osmode"))
 (setq cm (getvar "cmdecho"))
 ;;設置環境變數
 (setvar "osmode" 33)
 (setvar "cmdecho" 0)
 ;;依次讀取兩條直線的端點
 (initget 1)
 (setq p1 (getpoint"\n選擇第一條直線的第一個點"))
 (initget 1)
 (setq p2 (getpoint"\n選擇第一條直線的第二個點"))
 (initget 1)
 (setq p3 (getpoint"\n選擇第二條直線的第一個點"))
 (initget 1)
 (setq p4 (getpoint"\n選擇第二條直線的第二個點"))
 ;;;;恢復環境變數
 (setvar "osmode" os)
 (setq p1 (mid p1 p3 ))
 (setq p2 (mid p2 p4 ))
 (setq a (angle p1 p2))
 (setq p2 (polar p2 a 2.5))
 (setq p1 (polar p1 (+ pi a ) 2.5))
 (command "layer" "set" 5 "")
 (command "line" p1 p2 "")
)
(princ "\nC:GSL1 has loaded")
(Princ "\n for symmetry line")
Princ
 

 

Bookmark the permalink ,來源:
One thought on “AutoCAD下繪製直線對稱中心線的方法